#include "../api.h"
#include <stdio.h>

struct DLL_STRPICENV {
	int work[16384];
};
struct RGB {
	unsigned char b, g, r, t;
};

/* bmp.nasm */
int info_BMP(struct DLL_STRPICENV *env, int *info, int size, char *fp);
int decode0_BMP(struct DLL_STRPICENV *env, int size, char *fp, int b_type, char *buf, int skip);

/* jpeg.c */
int info_JPEG(struct DLL_STRPICENV *env, int *info, int size, char *fp);
int decode0_JPEG(struct DLL_STRPICENV *env, int size, char *fp, int b_type, char *buf, int skip);

unsigned char rgb2pal(int x, int y, int r, int g, int b);

void HariMain(void)
{
	struct DLL_STRPICENV env;
	struct RGB pbuf[786432], *q;
	unsigned char wbuf[837200], fbuf[524228], line[30], s[32], *p;
	int win, fsize, xsize, info[8], i, j;

	api_cline(line + 1, 30);
	i = api_fopen(line);
	if (i == 0) {
		api_puts("t@C܂B", -1);
		return;
	}
	fsize = api_fsize(i, 0);
	if (fsize > 524228) {
		api_puts("t@C傫܂B", -1);
		return;
	}
	api_fread(i, fbuf, fsize);
	api_fclose(i);

	if (info_BMP(&env, info, fsize, fbuf) == 0) {
		if (info_JPEG(&env, info, fsize, fbuf) == 0) {
			api_puts("ΉĂt@Cł͂܂B", -1);
			return;
		}
	}
	/* info[0] = t@C^Cvi1:BMP, 2:JPEGj
	  info[1] = J[
	  info[2] = xsize
	  info[3] = ysize */
	if (info[2] > 1024 || info[3] > 768) {
		api_puts("摜傫܂B", -1);
		return;
	}

	xsize = info[2] + 16;
	if (xsize < 136) {
		xsize = 136;
	}
	sprintf(s, "%s - 摜r[A", line);
	win = api_walloc(xsize, info[3] + 37, wbuf, s, -1);
	if (info[0] == 1) {
		i = decode0_BMP(&env, fsize, fbuf, 4, (char *) pbuf, 0);
	} else {
		i = decode0_JPEG(&env, fsize, fbuf, 4, (char *) pbuf, 0);
	}
	if (i != 0) {
		api_puts("t@CĂ܂B", -1);
		return;
	}

	for (i = 0; i < info[3]; i++) {
		p = wbuf + (i + 29) * xsize + (xsize - info[2]) / 2;
		q = pbuf + i * info[2];
		for (j = 0; j < info[2]; j++) {
			p[j] = rgb2pal(j, i, q[j].r, q[j].g, q[j].b);
		}
	}
	api_wrefresh(win, (xsize - info[2]) / 2, 29, (xsize - info[2]) / 2 + info[2], 29 + info[3]);
	for (;;) {
		i = api_getc(1);
	}
}

unsigned char rgb2pal(int x, int y, int r, int g, int b)
{
	static int table[4] = { 3, 1, 0, 2 };
	int i;

	x &= 1;	/*  */
	y &= 1;
	i = table[y * 2 + x];	/* ԐFp̒萔 */
	r = (r * 21) / 256;	/* 0 - 20 */
	g = (g * 21) / 256;
	b = (b * 21) / 256;
	r = (r + i) / 4;	/* 0 - 5 */
	g = (g + i) / 4;
	b = (b + i) / 4;
	return 16 + r + g * 6 + b * 36;
}
